#  sac.defn.tcl

proc {Add_SAC_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]

   set CurrentVMEServer  $server
 
   set A16addrbase [first $addressinfo]
   define-vme-register $name xVME DELR            "-a$A16addrbase -w16 -o0x00 -prw -d16 -l0 -b0 -zd -i6"
   define-vme-register $name xVME STR             "-a$A16addrbase -w16 -o0x02 -prw -d16 -l0 -b0 -zd -i2"
   define-vme-register $name xVME Enable          "-a$A16addrbase -w16 -o0x02 -prw -d16 -l1 -b0 -zd"
   define-vme-register $name xVME CBUS            "-a$A16addrbase -w16 -o0x04 -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME EVCNT           "-a$A16addrbase -w16 -o0x06 -pro -d16 -l0 -b0 -zd"
   define-vme-register $name xVME MON0            "-a$A16addrbase -w16 -o0x08 -prw -d16 -l0 -b0 -zd -i0"
   define-vme-register $name xVME MON1            "-a$A16addrbase -w16 -o0x0a -prw -d16 -l0 -b0 -zd -i2"
   define-vme-register $name xVME Mode            "-a$A16addrbase -w16 -o0x0e -prw -d16 -l1 -b0 -zd -i0"
   define-vme-register $name xVME EVCLR           "-a$A16addrbase -w16 -o0x10 -pwo -d16 -l0 -b0"
   define-vme-register $name xVME ARM             "-a$A16addrbase -w16 -o0x14 -pwo -d16 -l0 -b0"
}


proc {SAC_DAQ-reset} {args} {
#   S9418
    global CurrentVMEServer EGallow

    set CurrentVMEServer [second $args]
    set module [first $args]

#      Offline the module - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.STR] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff

#    initialise - this will reset the module state machine
    initialise-vme-registers $module.*
    write-vme-registers $module.EVCLR 0
}

proc {SAC_DAQ-setup} {args} {
#   S9418
    global CurrentVMEServer EGallow

    set CurrentVMEServer [second $args]
    set module [first $args]

#    initialise
    initialise-vme-registers $module.*
    write-vme-registers $module.EVCLR 0
}

proc {SAC_DAQ-halt} {args} {
#   S9418
    global CurrentVMEServer EGallow

    set CurrentVMEServer [second $args]
    set module [first $args]

    write-vme-register $module.STR 2
    write-vme-register $module.STR 0
}

proc {SAC_DAQ-go} {args} {
#   S9418
    global CurrentVMEServer EGallow

    set CurrentVMEServer [second $args]
    set module [first $args]
}


#   for parameter save/restore
set {SAC_registersavepatterns} {Mode DELR}


#    The following 3 procedures are used by the sys task for DA control
#    They can be called even if no SAC is present (as long as it is not declared)
#proc SAC_GO   {} {write-vme-registers sac#?.STR 1}
#proc SAC_STOP {} {write-vme-registers sac#?.STR 0}
#proc SAC_RESET {} {write-vme-registers sac#?.STR 2}
#proc SAC_STAT {} {return [read-vme-register sac#1.Enable]}
