#  V550.defn.tcl

proc {Add_CAEN V550_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]
   set interruptlevel [fourth $addressinfo]
   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server
 
   define-vme-register $name xVME Intr_Level          "-a$A32addrbase -w32 -o0x00 -pwo -d16 -l3 -b8 -zd -i$interruptlevel"
   define-vme-register $name xVME Intr_Vec            "-a$A32addrbase -w32 -o0x00 -pwo -d16 -l8 -b0 -zd -i$interruptvector"
   
   for {set i 0} {$i < 2048} {incr i} {
      define-vme-register $name xVME Ch0.Threshold$i      "-a$A32addrbase -w32 -o[expr 0x2000+($i*4)] -prw -d32 -l12 -b0 -zd -i16"
      define-vme-register $name xVME Ch0.Pedestal$i       "-a$A32addrbase -w32 -o[expr 0x2000+($i*4)] -prw -d32 -l12 -b12 -zd -i0"
   }
   
   for {set i 0} {$i < 2048} {incr i} {
      define-vme-register $name xVME Ch1.Threshold$i      "-a$A32addrbase -w32 -o[expr 0x4000+($i*4)] -prw -d32 -l12 -b0 -zd -i16"
      define-vme-register $name xVME Ch1.Pedestal$i       "-a$A32addrbase -w32 -o[expr 0x4000+($i*4)] -prw -d32 -l12 -b12 -zd -i0"
   }

   define-vme-register $name xVME Clear               "-a$A32addrbase -w32 -o0x06 -prw -d16"

   define-vme-register $name xVME Status              "-a$A32addrbase -w32 -o0x02 -prw -d16 -l10 -b0 -zx"
   define-vme-register $name xVME Status.TM           "-a$A32addrbase -w32 -o0x02 -prw -d16 -l1 -b0 -zd"
   define-vme-register $name xVME Status.MO           "-a$A32addrbase -w32 -o0x02 -prw -d16 -l1 -b1 -zd"
   define-vme-register $name xVME Status.Ch0.DRDY     "-a$A32addrbase -w32 -o0x02 -pro -d16 -l1 -b2 -zd"
   define-vme-register $name xVME Status.Ch1.DRDY     "-a$A32addrbase -w32 -o0x02 -pro -d16 -l1 -b3 -zd"
   define-vme-register $name xVME Status.Ch0.FMTY     "-a$A32addrbase -w32 -o0x02 -pro -d16 -l1 -b4 -zd"
   define-vme-register $name xVME Status.Ch1.FMTY     "-a$A32addrbase -w32 -o0x02 -pro -d16 -l1 -b5 -zd"
   define-vme-register $name xVME Status.Ch0.FHF      "-a$A32addrbase -w32 -o0x02 -pro -d16 -l1 -b6 -zd"
   define-vme-register $name xVME Status.Ch1.FHF      "-a$A32addrbase -w32 -o0x02 -pro -d16 -l1 -b7 -zd"
   define-vme-register $name xVME Status.Ch0.FFULL    "-a$A32addrbase -w32 -o0x02 -pro -d16 -l1 -b8 -zd"
   define-vme-register $name xVME Status.Ch1.FFULL    "-a$A32addrbase -w32 -o0x02 -pro -d16 -l1 -b9 -zd"

   define-vme-register $name xVME Ch0.NumChan       "-a$A32addrbase -w32 -o0x04 -prw -d16 -l6 -b0 -zd"
   define-vme-register $name xVME Ch1.NumChan       "-a$A32addrbase -w32 -o0x04 -prw -d16 -l6 -b6 -zd"

   define-vme-register $name xVME Ch0.TestPatt      "-a$A32addrbase -w32 -o0x14 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Ch0.WordCount     "-a$A32addrbase -w32 -o0x10 -pro -d16 -l0 -b0 -zd"
   define-vme-register $name xVME Ch0.FIFO          "-a$A32addrbase -w32 -o0x08 -pro -d32 -l0 -b0 -zx"
   
   define-vme-register $name xVME Ch1.TestPatt      "-a$A32addrbase -w32 -o0x16 -pwo -d16 -l0 -b0 -zx"
   define-vme-register $name xVME Ch1.WordCount     "-a$A32addrbase -w32 -o0x12 -pro -d16 -l0 -b0 -zd"
   define-vme-register $name xVME Ch1.FIFO          "-a$A32addrbase -w32 -o0x0c -pro -d32 -l0 -b0 -zx"
   
   define-vme-register $name xVME ModID#1           "-a$A32addrbase -w32 -o0xfe -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ModID#2           "-a$A32addrbase -w32 -o0xfc -pro -d16 -l0 -b0 -zx"
   define-vme-register $name xVME ModID#3           "-a$A32addrbase -w32 -o0xfa -pro -d16 -l0 -b0 -zx"
}

proc {CAEN V550_registers} {} {
    global registers_table

    set registers_table   {                                              \
        {"Interrupt Level Register"            Intr_Level}               \
        {"Interrupt Vector Register"           Intr_Vec}                 \
        {"Status Register"                     Status}                   \
        {"Number of detectors for readout Ch0" Ch0.NumChan}              \
        {"Number of detectors for readout Ch0" Ch1.NumChan}              \
        {"Test Pattern Register Ch0"           Ch0.TestPatt}             \
        {"Test Pattern Register Ch1"           Ch1.TestPatt}             \
        {"Word Counter Register Ch0"           Ch0.WordCount}            \
        {"Word Counter Register Ch1"           Ch1.WordCount}            \
        {"FIFO Ch0"                            Ch0.FIFO}                 \
        {"FIFO Ch1"                            Ch1.FIFO}                 \
        {"Module ID Word 1"                    ModID#1}                  \
        {"Module ID Word 2"                    ModID#2}                  \
        {"Module ID Word 3"                    ModID#3}                  \
    }
}


proc {CAEN V550_DAQ-reset} {args} {
#   V550
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.ModID#1] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {CAEN V550_DAQ-flush} {args} {
#   V550
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    
}

proc {CAEN V550_DAQ-go} {args} {
#   V550
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    
}

proc {CAEN V550_DAQ-halt} {args} {
#   V550
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    
}

proc {CAEN V550_DAQ-setup} {args} {
#   V550
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

}

#   for parameter save/restore
set {CAEN V550_registersavepatterns} {}

